/* Play audio data in reverse */

.include "ubc-de1media-macros.s"

.global _start

.text
_start:	movia	r23, IOBASE

restart:	movia	r21, WAV_END-4	/* play backwards */
		movia	r22, WAV_START

nextsound:	ldh	r4, 0(r21)		/* load sound sample from memory */
		ldh	r5, 2(r21)
		call	playsound

		addi	r21, r21, -4		/* go to next audio sample */
		bgeu	r21, r22, nextsound	/* address comparisons are unsigned */

		br	restart


playsound:	ldwio	r2, SNDRDY(r23)
		srli	r2, r2, 24		/* r2: # words avail in buffer */
		beq	r2, r0, playsound	/* if DAC buffer is full, wait */
		sthio	r4, SNDL(r23)	/* send sound sample to DAC */
		sthio	r5, SNDR(r23)
		ret


/* Wav data is 16 bit (signed), stereo, sampled at 44.1kHz */

.data

WAV_START:
.include	"wavdata2.s"
WAV_END:

.end