/* Print a null-terminated ASCII string on the terminal using putchar */

.include "ubc-de1media-macros.s"

.global _start

.text
_start:	movia	sp, DRAM_END	/* init stack pointer */
		movia	r23, IOBASE

		movia	r22, string
putmsg:	ldb	r4, 0(r22)		/* get next char to send */
		beq	r4, r0, donesend

		call	putchar		/* send next char */
		addi	r22, r22, 1
		br	putmsg		/* go get next char */

donesend:
echo_kb:	call	getchar		/* get char from user */
		mov	r4, r2
		call	putchar		/* echo it back to user */
		br	echo_kb


/* ***************************************************************** */
putchar:	ldwio	r2, TERMINALCTL(r23)
		srli	r2, r2, 16
		beq	r2, r0, putchar		/* wait to transmit */
		stwio	r4, TERMINAL(r23)		/* send char */
		ret


/* ***************************************************************** */
getchar:	ldwio	r2, TERMINAL(r23)		/* r2 gets char plus more info */
		andi	r3, r2, 0x8000		/* bit 15 of r2 = 1 means char ready */
		beq	r3, zero, getchar		/* wait to receive */
		andi	r2, r2, 0xff		/* optional: isolate single byte */
		ret


/* ***************************************************************** */

.data

string:
.asciz	"Hello, world. Please type a message below.\n"

.end
