.include "ubc-de1media-macros.s"

.global _start

.text
_start:	movia	sp, DRAM_END	/* init stack pointer */
		movia	r23, IOBASE

		movi	r4, '0'
		call	putchar

		movia	r4, string
		call	putstring

done:		call	getchar		/* get char from user */
		mov	r4, r2
		call	putchar		/* echo char back to user */
		br	done

/* ***************************************************************** */

putstring:	ldb	r2, 0(r4)			/* get next char to send */
		bne	r2, r0, putstrwait
		ret					/* at end of string, done */

putstrwait:	ldwio	r3, TERMINALCTL(r23)
		srli	r3, r3, 16
		beq	r3, r0, putstrwait	/* wait to transmit */

		stwio	r2, TERMINAL(r23)		/* send char */
		addi	r4, r4, 1
		br	putstring			/* go get next char */

/* ***************************************************************** */

putchar:	ldwio	r2, TERMINALCTL(r23)
		srli	r2, r2, 16
		beq	r2, r0, putchar		/* wait to transmit */
		stwio	r4, TERMINAL(r23)		/* send char */
		ret

/* ***************************************************************** */

getchar:	ldwio	r2, TERMINAL(r23)		/* r2 gets char plus more info */
		andi	r3, r2, 0x8000		/* bit 15 of r2 = 1 means char ready */
		beq	r3, zero, getchar		/* wait to receive */
		andi	r2, r2, 0xff		/* optional: isolate single byte */
		ret

/* ***************************************************************** */

.data

string:
.asciz	"Hello, world. Please type a message below.\n"

.end
