/* Print a null-terminated ASCII string on the terminal using putstring */

.include "ubc-de1media-macros.s"

.global _start

.text
_start:	movia	sp, DRAM_END	/* init stack pointer */
		movia	r23, IOBASE

		movia	r4, string
		call	putstring

stop:		br stop


/* ***************************************************************** */
putstring:	ldb	r2, 0(r4)			/* get next char to send */
		bne	r2, r0, putstrwait
		ret					/* at end of string, done */

putstrwait:	ldwio	r3, TERMINALCTL(r23)
		srli	r3, r3, 16
		beq	r3, r0, putstrwait	/* wait to transmit */

		stwio	r2, TERMINAL(r23)		/* send char */
		addi	r4, r4, 1
		br	putstring			/* go get next char */


/* ***************************************************************** */

.data

string:
.asciz	"Hello, world.\n"

.end
